package be.six.reports.data;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.Vector;

import javax.swing.JComboBox;
import javax.swing.JComponent;

import be.six.reports.util.Configuration;
import be.six.reports.util.ListItem;
import be.six.reports.util.Configuration.ConfigurationKey;

public class ListParameter extends Parameter {
	
	private static HashMap<String,Vector<ListItem>> listParameters;
	
	final JComboBox combobox;	
	public ListParameter(String name) {
		super(name);
		ListParameter.initializeListParameters();
		combobox = new JComboBox(listParameters.get(type));
	}
	
	private static HashMap<String,Vector<ListItem>> initializeListParameters(){
		if(listParameters==null){
			listParameters = new HashMap<String,Vector<ListItem>>();
			String paramsAsString = Configuration.get(ConfigurationKey.list_queries);
			String[] paramsAsStringArray = paramsAsString.split("\\|");
			for(String param : paramsAsStringArray){
				String[] data = param.split(":");
				String name = data[0].trim();
				String sql = data[1];
				Vector<ListItem> items = new Vector<ListItem>();
				try {
					DatabaseResult result = Database.getInstance().fetchData(sql);
					items = ListItem.convertDatabaseResult(result);
					
				} catch (SQLException e) {
					e.printStackTrace();
				}
				listParameters.put(name,items);
			}			
		}
		return listParameters;
	}
	

	@Override
	public JComponent getComponent() {
		return combobox;
	}

	@Override
	public Object getValue() {
		return ((ListItem)combobox.getSelectedItem()).getKey();
	}

	public static boolean isListParameter(String name) {
		initializeListParameters();
		for(String key : listParameters.keySet()){
			if(name.toLowerCase().startsWith(key))
				return true;
		}
		return false;
	}

}
