package be.six.reports.data;

import javax.swing.JComponent;
import javax.swing.JTextField;


public class SQLParameter  extends Parameter{
	
	public static boolean isSQLParameter(String name){
		if(name == null)
			throw new IllegalArgumentException("name");

		if(name.toLowerCase().startsWith("sql"))
			return true;

		return false;
	}

	final JTextField component;
	public SQLParameter(String name){
		super(name);
		component=new JTextField();
	}
	
	public JComponent getComponent() {
		return component;
	}

	@Override
	public Object getValue() {
		return component.getText();
	}
	
	public String replaceSQL(String originalSQL){
		String completeName = "!\\{" + type + description + "\\}!";
		return 	originalSQL.replaceAll(completeName, getValue().toString());
	}
}
