package be.six.reports.ui;

import java.awt.BorderLayout;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;

import com.jgoodies.forms.builder.DefaultFormBuilder;
import com.jgoodies.forms.factories.ButtonBarFactory;
import com.jgoodies.forms.layout.FormLayout;

/**
 * A panel with an export and execute button.
 * @author Joren Six
 */
public class ButtonPanel extends JPanel {
	private static final long serialVersionUID = -5284983220690705732L;
	private JButton export,execute;
	
	/**
	 * Creates a new button panel. Uses FormLayout.
	 */
	public ButtonPanel(){		
		super();
		export=new JButton("CSV Export");
		execute=new JButton("Execute");
		
		FormLayout layout = new FormLayout("min:grow","p");
        DefaultFormBuilder builder = new DefaultFormBuilder(layout);
        builder.setDefaultDialogBorder();
        builder.setRowGroupingEnabled(true);
        	
		JPanel panel = ButtonBarFactory.buildCenteredBar(export,execute);
		builder.append(panel);
		
		this.add(builder.getPanel(),BorderLayout.CENTER);		
	}
	
	/**
	 * Adds a listener to the CSV export button.
	 * @param listener the listener to add to the button
	 */
	public void addListenerToExportButton(ActionListener listener){
		export.addActionListener(listener);
	}
	
	/**
	 * Adds a listener to the execute query button.
	 * @param listener the listener to add to the button
	 */
	public void addListenerToExecuteButton(ActionListener listener){
		execute.addActionListener(listener);
	}
	
}
