package be.six.reports.ui;

import java.awt.BorderLayout;
import java.util.HashMap;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;

import be.six.reports.util.Configuration;
import be.six.reports.util.Configuration.ConfigurationKey;

import com.jgoodies.forms.builder.DefaultFormBuilder;
import com.jgoodies.forms.layout.FormLayout;

/**
 * A panel to configure the configuration parameters.
 * @author joren
 *
 */
public class ConfigurationPanel extends JPanel {
	private static final long serialVersionUID = 773663466708366659L;
	private final HashMap<JTextField,ConfigurationKey> configurationTextFields;
	
	public ConfigurationPanel(){
		super(new BorderLayout());         
		
        FormLayout layout = new FormLayout("right:pref, 3dlu, min:grow");
        DefaultFormBuilder builder = new DefaultFormBuilder(layout);
        configurationTextFields  = new HashMap<JTextField,ConfigurationKey>();
        builder.setDefaultDialogBorder();
        builder.setRowGroupingEnabled(true);
        builder.appendSeparator("Configuratieparameters");         
        for(ConfigurationKey key : ConfigurationKey.values()){
        	JTextField configurationTextField = new JTextField();
        	String value = Configuration.get(key);
        	configurationTextField.setText(value);
        	builder.append(key.name() + ":",configurationTextField,true);
        	configurationTextFields.put(configurationTextField,key);
        	configurationTextField.addCaretListener(new CaretListener() {			
				public void caretUpdate(CaretEvent e) {
					JTextField textField = (JTextField) e.getSource();
					ConfigurationKey key = configurationTextFields.get(textField);
					String value = textField.getText();
					Configuration.set(key, value);
				}
			});
        }                       
     
        JComponent center =  builder.getPanel();
        add(center,BorderLayout.CENTER);
	}

}
