package be.six.reports.ui;

import javax.swing.table.AbstractTableModel;

import be.six.reports.data.DatabaseResult;

/**
 * A table model for a JDBC table, built using meta data.
 * @author Joren Six
 * 
 */
public class JDBCTableModel extends AbstractTableModel {

	private static final long serialVersionUID = 6957638325346438983L;
	private final DatabaseResult result;
	
	/**
	 * Creates a new JDBCTableModel, representing the DatabaseResult.
	 * @param result
	 */
	public JDBCTableModel(DatabaseResult result){
		super();
		this.result=result;
	}
	
	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	public int getRowCount() {
		return result.getRowCount();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	public int getColumnCount() {
		return result.getColumnCount();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getValueAt(int, int)
	 */
	public Object getValueAt(int row, int column) {
		return result.getValueAt(row,column);
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#getColumnClass(int)
	 */
	@Override
	public Class<?> getColumnClass(int col) {
		return result.getColumnClass(col);
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#getColumnName(int)
	 */
	public String getColumnName(int col) {
		return result.getColumName(col);
	}
}
