package be.six.reports.ui;


import java.awt.Cursor;
import java.awt.Dimension;

import javax.swing.JFrame;
import javax.swing.JSplitPane;

/**
 * MainFrame haha, mainframe. This is the main ... frame. 
 * @author Joren Six 
 */
public class MainFrame extends JFrame {

	private static final long serialVersionUID = 4564833333897889106L;

	private final JSplitPane splitPane;
	private final Grid grid;
	
	
	/**
	 * Creates the frame, adds the grid a tab pane using a splitter.
	 */
	public MainFrame(){
		super("Query Tool");
		
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		//Create and set up the content pane.
        grid = new Grid();
        grid.setOpaque(true); //content panes must be opaque
            
        splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT,new ReportTypeTabs(grid),grid);
        splitPane.setOneTouchExpandable(true);
        splitPane.setDividerLocation(420);
        
        setContentPane(splitPane);
    
        //Display the window.
        this.setMinimumSize(new Dimension(650,550));
        
        setLocationRelativeTo(null);
        setVisible(true);
	}
	
	/**
	 * Sets the application to wait state: show a wait cursor. If the application is 
	 * in wait state: show the normal cursor.
	 */
	public void toggleWait(){
		if(getCursor() == Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR))
			setCursor(null);
		else
			setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
		
		grid.toggleWait();
	}
	
}
